<template>
  <div>
    <no-ssr>
      <MapContainer @ready="loadMap" />
    </no-ssr>
    <SoundButton
      ref="soundButton"
      :src="music"
      :loop="true"
      :autoplay="true"
      class="btn music-button"
    />
  </div>
</template>

<script>
import { createNamespacedHelpers } from 'vuex'
import SoundButton from 'vue-howler-button/src/components/SoundButton.vue'
import MapContainer from '~/components/map-container-helper'

const mapModule = createNamespacedHelpers('map')

export default {
  name: 'TwilightWorld',

  components: {
    MapContainer,
    SoundButton
  },

  computed: {
    music() {
      const baseUrl = this.$router.options.base
      return ['music/twilight-world.ogg', 'music/twilight-world.mp3'].map(
        url => baseUrl + url
      )
    }
  },

  beforeDestroy() {
    this.$refs.soundButton.howl.stop()
  },

  methods: {
    ...mapModule.mapActions(['setMapFilePath', 'setOverlay']),

    loadMap() {
      this.setMapFilePath('maps/twilight_world.json').then(() =>
        setTimeout(() => this.$store.dispatch('twilight-world/next'), 200)
      )
    }
  }
}
</script>
